Summary:  Squid Internet Object Cache
Name: squid-rhcn
Version: 2.2.STABLE3
Release: 1
Packager: Red Hat Contrib|Net <rhcn-bugs@redhat.com>
Distribution: Red Hat Contrib|Net
URL: http://squid.nlanr.net/
Source: http://squid.nlanr.net/Squid/v2/2.2/squid-%{version}-src.tar.gz
Source1: squid-faq-19990420.tgz
Source2: squid.init
Source3: squid.logrotate
Source4: squid.sysconfig
Patch1: squid-2.2-misc.patch
Patch2: squid-FAQ.patch
Copyright: GPL
Group: Networking/Daemons
BuildRoot: /tmp/squid-root
Requires: chkconfig >= 0.9, shadow-utils >= 970616, logrotate
Obsoletes: squid+icmp-beta, squid-novm, squid-beta, squid, squid+icmp
Provides: squid

# The following is needed later; you can change this:
%define squid_uid 15
%define squid_gid 51

%changelog
* Tue Apr 20 1999 Alexey Nogin <ayn2@cornell.edu>
- Updated to 2.2.STABLE1 and fetched the latest FAQ

* Fri Jan 29 1999 Alexey Nogin <ayn2@cornell.edu>
- Updated to 2.2.PRE1 and fetched the latest FAQ
- /etc/rc.d/init.d/squid improvements

* Wed Dec  9 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to 2.1.PATCH2 and fetched the latest FAQ
- %preun script fixes

* Thu Nov 19 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to 2.1.PATCH1
- Changed name to squid-rncn (according to RHCN rules)
- %postun script fixes

* Tue Nov 17 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to 2.1.RELEASE
- Changed SRPM according to RHCN Package Requirements
- Automatically include all available error pages translations into RPM
  (do not discriminate against Russian-1251)

* Thu Nov 12 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to 2.1.PRE4 and fetched the latest FAQ

* Wed Oct 14 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to 2.0.PATCH2
- Rotate logs with squid -k rotate, not with kill -USR1 <pid>

* Fri Oct  3 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to 2.0 release
- Fixed the HOME_DIR setting in the %post script

* Fri Sep 25 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to 1.2.beta25
- Fetched the lastest FAQ from http://squid.nlanr.net/Squid/FAQ/
- Added the patch to fix links in the FAQ

* Sun Aug 30 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to 1.2.beta24 + Patch 1
- Fixed (hopefully) the log rotation

* Sun Aug 16 1998 Alexey Nogin <ayn2@cornell.edu>
- Fixed a bug in the %post script

* Sat Aug 15 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to 1.2.beta23 + Patch Set 4
- Added Squid FAQ
- squid.conf.default is now readable only by group squid
- If squid.conf does not exist when installing squid, copy
  squid.conf.default to squid.conf
- Rotate logs with logrotate, not cron
- Added turkish error pages
- SRPM: Added %attr directive. Now we do not have to create squid
  user and group in the %pre script
- SRPM: Have init files as separate Sources, not in the patch.
- Many changes in these release are inspired by the Squid RPMs by
  Arne Coucheron <arneco@online.no>

* Sat May 31 1998 Alexey Nogin <ayn2@cornell.edu>
- Changed the package name from squid-1.2.beta21 to squid-beta-1.2.21

* Sat May 23 1998 Alexey Nogin <ayn2@cornell.edu>
- Added error pages in various languages to the binary RPM
- The defaut error dir is changed to /etc/squid/errors/English

* Tue Mar  3 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to 1.2-beta15
- Removed unnecessary setresuid() fix (configure now checks it correctly)
  cachemgr.cgi was going to /home/httpd/cgi-bin and was immediatelly
  accessible - not too secure, moved it to /usr/lib/squid, you may make
  a symbolic link if you need to make it accessible
- All scripts are now %configs (I like customizing scripts and I do not like,
  when RPM replaces my scripts)
- This RPM is base on squid-1.NOVM RPM by Jan "Yenya" Kasprzak <kas@fi.muni.cz>

%description
Squid is a high-performance proxy caching server for web clients,
supporting FTP, gopher, and HTTP data objects.  Unlike traditional
caching software, Squid handles all requests in a single,
non-blocking, I/O-driven process.

This package does not have ICMP network probe database (Netdb) compiled in.

WARNING: If you upgrade from earlier version
of squid (1.1.x or 1.NOVM.x), you will
LOSE YOUR CACHE

Please read the documentation!!

%prep
%setup -n squid-%{version} -q -a 1
%patch1 -p1
%patch2 -p0

%build
CFLAGS="$RPM_OPT_FLAGS" LDFLAGS=-s  \
	./configure --prefix=/usr   \
	--exec_prefix=/usr          \
	--bindir=/usr/sbin          \
	--libexecdir=/usr/lib/squid \
	--localstatedir=/var        \
	--sysconfdir=/etc/squid
make -f makefile

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/{bin,sbin,lib/squid}
mkdir -p $RPM_BUILD_ROOT/etc/{squid/{icons,errors},sysconfig,{logrotate,rc.d/{rc{0,1,2,3,5,6},init}}.d}
mkdir -p $RPM_BUILD_ROOT/home/httpd/cgi-bin
mkdir -p $RPM_BUILD_ROOT/usr/man/man3
mkdir -p $RPM_BUILD_ROOT/var/{cache,log/squid}

install -m 755 %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/squid
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT/etc/logrotate.d/squid
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT/etc/sysconfig/squid
install -m 755 doc/tree.3 $RPM_BUILD_ROOT/usr/man/man3/tree.3
install -s -m 755 src/squid $RPM_BUILD_ROOT/usr/sbin/
install -s -m 755 src/client $RPM_BUILD_ROOT/usr/bin
install -s -m 755 src/{pinger,dnsserver,unlinkd,cachemgr.cgi} $RPM_BUILD_ROOT/usr/lib/squid
install -m 644 src/mime.conf src/mib.txt $RPM_BUILD_ROOT/etc/squid
install -m 644 src/squid.conf $RPM_BUILD_ROOT/etc/squid/squid.conf.default
install -m 444 icons/*.gif $RPM_BUILD_ROOT/etc/squid/icons
install -m 755 scripts/{RunCache,RunAccel} $RPM_BUILD_ROOT/usr/sbin/

cd errors
for i in *; do
   if [ -d $i ]; then
      mkdir $RPM_BUILD_ROOT/etc/squid/errors/$i
	   install -m 644 $i/* $RPM_BUILD_ROOT/etc/squid/errors/$i
   fi
done

%pre
test -r /var/lock/subsys/squid -a -r /etc/rc.d/init.d/squid.init \
	&& /etc/rc.d/init.d/squid.init stop
test -r /var/lock/subsys/squid -a -r /etc/rc.d/init.d/squid \
	&& /etc/rc.d/init.d/squid stop
# Add the squid user and group to the system files:
# If you change this, change the %prep script too.
if grep -q '^squid:' /etc/group
then true
else
	if grep -q '^[^:]*:[^:]*:%{squid_gid}:' /etc/group
	then
		cat <<EOF
!!! Squid group is not in /etc/group, but there is another group with
!!! the %squid_gid GID. You may want to create a squid user and then
!!! change the ownership of the /var/cache and /var/log/squid
!!! directories to it.
EOF
	else
		/usr/sbin/groupadd -g %{squid_gid} -r squid && echo "Squid group added to /etc/group."
	fi
fi
if grep -q '^squid:' /etc/passwd
then true
else
	if grep -q '^[^:]*:[^:]*:%{squid_uid}:' /etc/passwd
	then
		cat <<EOF
!!! Squid user is not in /etc/passwd, but there is another user with
!!! the %squid_uid UID. You may want to create a squid user and then
!!! change the ownership of the /var/cache and /var/log/squid
!!! directories to it.
EOF
	else
		/usr/sbin/useradd -r -c 'Squid - WWW proxy cache' -d /var/cache -g 51 -u 15 squid && echo "Squid user created."
	fi
fi

%post
if [ ! -e /etc/squid/errors/Russian ]; then
   ln -s Russian-koi8-r /etc/squid/errors/Russian
fi
if [ "$1" -gt 1 ]
then
	/etc/rc.d/init.d/squid start
	exit 0
fi
if test ! -e /etc/squid/squid.conf; then
	cp -a /etc/squid/squid.conf.default /etc/squid/squid.conf
fi	
/sbin/chkconfig --add squid
HOME_DIR=/var/cache
if test -r /etc/squid/squid.conf \
	&& grep -q '^[ 	]*cache_dir' /etc/squid/squid.conf
then
	HOME_DIR="`grep '^[ 	]*cache_dir' /etc/squid/squid.conf | \
		sed 's/^[ 	]*cache_dir[ 	]*//'|awk '{print $1}'|head -1`"
fi
if test -d $HOME_DIR/00
then true
else
   /usr/sbin/squid -z
fi
cat <<EOF
You may want to edit /etc/squid/squid.conf and then start squid
using a "/etc/rc.d/init.d/squid start" command.
EOF

%preun
[ "$1" -ne 0 ] && exit 0
rm -f /etc/squid/errors/Russian
test -r /etc/rc.d/init.d/squid && \
	/etc/rc.d/init.d/squid stop
/sbin/chkconfig --del squid

%postun
[ "$1" -ne 0 ] && exit 0
HOME_DIR=/var/cache
if [ -r /etc/squid/squid.conf ] && grep -q '^[    ]*cache_dir' /etc/squid/squid.conf
then
   HOME_DIR="`(echo /var/cache; grep '^[  ]*cache_dir' /etc/squid/squid.conf | \
      sed 's/^[   ]*cache_dir[   ]*//'|awk '{print $1}')|sort -u|xargs echo`"
fi
if [ -d /var/log/squid ]; then
   echo "You may want to delete Squid log directory /var/log/squid"
fi
for i in $HOME_DIR; do
   if [ -d $i ]; then
      echo "You may want to delete Squid cache directory "$i
   fi
done

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc doc/HTTP-codes.txt doc/Release-Notes-1.0.txt doc/Release-Notes-1.1.txt
%doc doc/icpv2-application.txt doc/icpv2-protocol.txt doc/debug-sections.txt
%doc doc/mk-debugs.sh doc/draft-vixie-icp-htcp-01.txt
%doc CONTRIBUTORS COPYING ChangeLog INSTALL README QUICKSTART CREDITS TODO FAQ
/usr/sbin/squid
/usr/bin/client
/usr/lib/squid
%attr(-,root,man)/usr/man/man3/tree.3
/etc/squid/icons
%attr(-,squid,squid)%dir /var/cache
%dir /etc/squid
%dir /etc/squid/errors
%dir /etc/squid/errors/*
%config /etc/squid/errors/*/*
%config /etc/logrotate.d/squid
%config /etc/rc.d/init.d/squid
%config /usr/sbin/RunCache
%config /usr/sbin/RunAccel
%config /etc/sysconfig/squid
%attr(640,root,squid)%config /etc/squid/squid.conf.default
%config /etc/squid/mime.conf
%config /etc/squid/mib.txt
%attr(-,squid,squid)%dir /var/log/squid
